<template>
    <div>
        <div class="bg-white border-b-8 border-gray-300 p-4 w-full">
            <app-post-create/>
        </div>

        <app-post 
            v-for="post in posts"
            :key="post.id"
            :post="post"
            class="cursor-pointer"
        />

        <div v-if="posts.length" v-observe-visibility="{callback: handleScrolledToBottom}">
            
        </div>
    </div>
</template>
<script>
import { mapGetters, mapActions } from 'vuex';
export default {
    data() {
        return {
            page: 1,
            lastPage: 1
        }
    },

    computed: {
        ...mapGetters({
            posts: 'timeline/posts'
        }),

        urlWithPage() {
            return `/api/timeline?page=${this.page}`;
        }
    },

    methods: {
        ...mapActions({
            getPosts: 'timeline/getPosts'
        }),

        loadPosts() {
            this.getPosts(this.urlWithPage).then(response => {
                this.lastPage = response.data.meta.last_page
            });
        },

        handleScrolledToBottom(isVisible) {
            if(!isVisible) {
                return
            }

            if(this.lastPage === this.page){
                return
            }

            this.page++;
            this.loadPosts();
             
        }
    },

    mounted() {
        this.loadPosts();
    }
}
</script>